package test;


import org.hou.stocktank.base.StrategyFactory;
import org.hou.stocktank.services.BossaSingleFileDataProviderService;
import org.hou.stocktank.strategies.IchimokuStrategyFactory;
import org.hou.stocktank.utils.TimeSeriesUtils;
import org.hou.stocktank.utils.evaluation.StrategyTester;
import org.hou.stocktank.utils.evaluation.StrategyTestingResultFields;
import org.joda.time.DateTime;
import org.ta4j.core.TimeSeries;

import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

public class MultistockStrategyTest {
    private static final List<String> stocks = Arrays.asList("JUJUBEE","PROCHNIK","ENEA","SANOK","BUMECH","01CYBATON","06MAGNA","08OCTAVA","11BIT","2CPARTNER","2INTELLECT","4FUNMEDIA","5THAVENUE","AATHOLD","ABADONRE","ABAK","ABCDATA","ABMSOLID","ABPL","ABSINVEST","ACARTUS","ACAUTOGAZ","ACREBIT","ACTION","ADIUVO","ADMIRAL","AEDES","AERFINANC","AFHOL","AGORA","AGROLIGA","AGROMA","AGROTON","AGROTOUR","AGROWILL","AILLERON","AIRWAY","AITON","AKCEPTFIN","ALCHEMIA","ALDA","ALEJA","ALIOR","ALKAL","ALMA","ALTA","ALTERCO","ALTUSTFI","ALUMAST","ALUMETAL","AMBRA","AMICA","AMREST","ANALIZY","APANET","APATOR","APIS","APLISENS","APS","APSENERGY","AQUABB","AQUAPOZ","ARAMUS","ARCTIC","ARCUS","ARENAPL","ARI","ARRINERA","ARTERIA","ARTNEWMED","ARTP","ASBIS","ASSECOBS","ASSECOPOL","ASSECOSEE","ASSECOSLO","ASSETUS","ASTARTA","ASTRO","ATAL","ATCCARGO","ATENDE","ATHOS","ATLANTAPL","ATLANTIS","ATLASEST","ATM","ATMGRUPA","ATONHT","ATREM","AUTOSPA","AVIAAML","AVIASG","AWBUD","AZTEC","B2BPARTNER","B3SYSTEM","BACD","BALTICINV","BALTICON","BALTONA","BBCONSULT","BBIDEV","BEDZIN","BENEFIT","BERLING","BEST","BETACOM","BGE","BGZBNPP","BINARY","BIOERG","BIOFACTOR","BIOGENED","BIOMASS","BIOMAX","BIOMAXIMA","BIOMEDLUB","BIOTON","BIPROMET","BLACKPOIN","BLIRT","BLOOBER","BLUETAX","BLUMERANG","BMPAG","BOA","BOGDANKA","BOM0221","BOMEDIA","BOOMERANG","BORUTA","BORYSZEW","BOS","BOWIM","BPC","BPHFIZBI2","BPHFIZBI4","BPHFIZMLI","BPHFIZSN","BPHFIZSN2","BPS0718","BPS0720","BPS1122","BPX","BRAS","BRASTER","BRIJU","BROADGATE","BSCDRUK","BUDIMEX","BUDOPOL","BUMECH","BYTOM","BZWBK","CALATRAVA","CALESCO","CAPITAL","CASHFLOW","CCC","CCENERGY","CCS","CCTOOLS","CDPROJEKT","CDRL","CELTIC","CENTURION","CEREALPLT","CEZ","CFBPS","CFI","CHEMOS","CIASTZKRA","CIECH","CIGAMES","CLOUD","CNT","COALENERG","COGNOR","COLIAN","COLUMBUS","COMARCH","COMECO","COMP","COMPERIA","COMPRESS","COPERNIC","CORMAY","CPGROUP","CPS0721","CSY","CUBEITG","CWPE","CYFRPLSAT","CZARNKOW","CZTOREBKA","DAMFINW","DANKS","DASE","DEBICA","DECORA","DEKTRA","DELKO","DENTAMDC","DEVORAN","DGA","DIGITAL","DOMDEV","DOMENOMAN","DOMLEK","DREWEX","DROP","DROZAPOL","DSS","DTP","DUON","DYWILAN","EASTSIDE","EASYCALL","EBC","EC2","ECERAMICS","ECHO","ECOTECH","EDINVEST","EDISON","EFEKT","EFENERGII","EFIXDM","EGB","EKIOSK","EKOBOX","EKOEXPORT","EKOKOGEN","EKOPOL","ELBUDOWA","ELEKTROTI","ELEMENTAL","ELKOP","ELZAB","EMCINSMED","EMMERSON","EMONT","EMPERIA","EMUZYKA","ENAP","ENEA","ENELMED","ENERGA","ENERGOINS","ENERGOPLD","EONET","EPIGON","EQUITIER","ERBUD","ERG","ERGIS","ERNE","ERS","ESKIMOS","ESOTIQ","ESPEROTIA","ESSYSTEM","ETFDAX","ETFSP500","ETFW20L","EUCO","EUIMPLANT","EUROCASH","EUROCENT","EUROSNACK","EUROTAX","EUROTEL","EVEREST","EXAMOBILE","EXCELLENC","EZO","FABRYKAKD","FACHOWCY","FAM","FAMUR","FARM51","FARMACOL","FASING","FASTFIN","FCHF","FCHFWS","FEERUM","FERRO","FERRUM","FEUR","FEURWS","FHDOM","FINHOUSE","FITEN","FLUID","FMG","FON","FOREVEREN","FORPOSTA","FORTE","FORTUNA","FOTA","FUSD","FUSDWS","FUTURIS","GALVO","GANT","GCINVEST","GEKOPLAST","GENERGY","GENOMED","GENRG","GEOTRANS","GEOTREKK","GETIN","GETINOBLE","GINOROSSI","GKSKAT","GLCOSMED","GLGPHARMA","GLOBALTR","GLOBCITYHD","GOBARTO","GOLAB","GORENJE","GOTFI","GPPI","GPW","GRAPHIC","GRAVITON","GREMINWES","GREMPCO","GRJAGUAR","GROCLIN","GRODNO","GRUPAAZOTY","GRUPAEMM","GRUPAHRC","GRUPAREC","GTC","GTRINITY","GWARANT","HAMBURGER","HANDLOWY","HARPER","HAWE","HEFAL","HELIO","HERKULES","HETAN","HFTGROUP","HMINWEST","HORTICO","HOTBLOK","HUBSTYLE","HURTIMEX","HUTMEN","HYDRAPRES","HYDROPHI","HYDROTOR","HYPERION","I3D","IAI","IALBGR","IBCPOLSKA","IBSM","ICPD","ICPGROUP","IDEABANK","IDEON","IDH","IDMSA","IFCAPITAL","IFM","IFSA","IGORIA","IIAAV","IMAGIS","IMCOMPANY","IMMOBILE","IMPEL","IMPERA","IMPEXMET","IMS","INBOOK","INC","INCANA","INDATA","INDYGO","INDYKPOL","INFOSYS","INFRA","INGBSK","INNOGENE","INPOST","INPRO","INSTALKRK","INTEGERPL","INTELIWIS","INTERAOLT","INTERBUD","INTERCARS","INTERFERI","INTERNITY","INTERSPPL","INTLDAX01800","INTROL","INVCEEFIZ","INVESTEKO","INVESTORMS","INVFIZ","INVGLDFIZ","INVICO","INVISTA","INVPEFIZ","INWESTPL","IPERMFIZ","IPODS","IPOPEMA","IQP","ISIAG","IU","IVMX","IZOBLOK","IZOLACJA","IZOSTAL","JANTAR","JHMDEV","JRHOLDING","JSW","JUJUBEE","JUPITER","JWCONSTR","JWWINVEST","K2INTERNT","KANCELWEC","KANIA","KBDOM","KCI","KDMSHIPNG","KERDOS","KERNEL","KETY","KGHM","KINOPOL","KKHERBAL","KLASZTORNE","KLEBAINV","KLON","KME","KOGENERA","KOMPAP","KOMPUTRON","KONSSTALI","KOPEX","KORBANK","KPPD","KRAKCHEM","KREC","KREDYTIN","KREZUS","KRKA","KRUK","KRUSZWICA","KSGAGRO","KUPIEC","LABOPRINT","LANGLOO","LARK","LARQ","LASERMED","LAURENPES","LCCORP","LENA","LENTEX","LEONIDAS","LETUS","LGTRADE","LIBERTY","LIBET","LIVECHAT","LOKATYBUD","LOTOS","LOYD","LPP","LSISOFT","LSTECHHOM","LUBAWA","LUG","LUXIMA","LZMO","M4B","MABION","MADKOM","MAKARONPL","MAKOLAB","MAKORA","MALKOWSKI","MANGATA","MARKA","MARSOFT","MARVIPOL","MAXIMUS","MAXIPIZZA","MBANK","MBFGROUP","MBPARTNER","MBWS","MCI","MCLOGIC","MDIENERGIA","MED","MEDAPP","MEDCAMP","MEDIACAP","MEDIANPOL","MEDIATEL","MEDICALG","MEGARON","MEGASONIC","MENNICA","MENNICASK","MERA","MERCATOR","MERCOR","MERIT","METROPOLIS","MEXPOLSKA","MFO","MFOOD","MGAMES","MGMSYS","MIDVEN","MILESTONE","MILKILAND","MILKPOL","MILLENNIUM","MINERAL","MINOX","MIRACULUM","MIRBUD","MLPGROUP","MMCPL","MNI","MOBIMEDIA","MOBINI","MOBRUK","MODE","MODECOM","MODERNCOM","MOJ","MOL","MOMO","MONDAY","MONNARI","MORIZON","MOSTALPLC","MOSTALWAR","MOSTALZAB","MOTORICUS","MPAY","MPLVERBUM","MUZA","MWTRADE","NANOTEL","NAVIMORIN","NCINDEX","NCINDEX30","NEPTIS","NETIA","NETMEDIA","NETWISE","NEUCA","NEWAG","NEWWORLDR","NFPL","NORTCOAST","NOTORIA","NOVAVIS","NOVINA","NOVITA","NOWAGALA","NTTSYSTEM","NWAI","ODLEWNIE","OEX","OLYMPIC","ONE2ONE","ONICO","OPENFIN","OPENNET","OPERA3GR","OPONEO.PL","OPTEAM","OPTIZENLB","ORANGEPL","ORBIS","ORCOGROUP","ORGANIC","ORION","ORPHEE","ORZBIALY","ORZLOPONY","OTLOG","OTMUCHOW","OVOSTAR","PAGED","PAMAPOL","PANOVA","PARCELTEC","PARTNER","PATENTUS","PATFUND","PBG","PBSFINANSE","PCCEXOL","PCCINTER","PCCROKITA","PCGUARD","PCHVENTURE","PCM","PEGAS","PEIXIN","PEKABEX","PEKAO","PELION","PEMANAGER","PEMUG","PEP","PEPEES","PETROLINV","PFH","PFLEIDER","PFMEDICAL","PGE","PGNIG","PGODLEW","PGPPOLONI","PGSSOFT","PHARMENA","PHN","PHOTON","PIK","PILAB","PKNORLEN","PKOBL1","PKOBP","PKOGS","PKOSO","PKPCARGO","PLANETINN","PLASMA","PLASTBOX","PLATIGE","PLATYNINW","PLAZACNTR","PMPG","POLCOLORIT","POLFA","POLICE","POLIMEXMS","POLINW","POLMAN","POLMED","POLNA","POLNORD","POLTRONIC","POLWAX","POLYMETAL","POZBUD","PPRICE","PRAGMAFA","PRAGMAINK","PRAIRIE","PREMFOOD","PRESENT24","PRESTO","PRIMAMODA","PRIME","PROCAD","PROCHEM","PROCHNIK","PROJPRZEM","PROLOG","PROMISE","PROPERTYF","PROTEKTOR","PROVECTA","PROVIDENT","PRYMUS","PTWP","PULAWY","PWRMEDIA","PYLON","PZU","QUANTUM","QUARKVENT","QUART","QUBICGMS","QUERCUS","QUMAK","RADPOL","RAFAKO","RAFAMET","RAINBOW","RAJDY4X4","RANKPROGR","RAWLPLUG","RCCOFAOPEN","RCCORAOPEN","RCCRUAOPEN","READGENE","REDAN","REDWOOD","REGNON","REINHOLD","RELPOL","REMAK","REMEDIS","RESBUD","RESPECT","REVITUM","ROBINSON","ROBYG","ROCCA","RONSON","ROPCZYCE","ROTOPINO","ROVESE","ROVITA","RSY","RUBICON","RUCHCHORZ","RUNICOM","S4E","SADOVAYA","SAKANA","SANOK","SANTANDER","SANWIL","SAPLING","SARE","SCOPAK","SEAMASTER","SECOGROUP","SECUSIFIZ","SEKA","SEKO","SELENAFM","SELVITA","SERINUS","SESCOM","SETANTA","SEVENET","SFD","SFERANET","SFINKS","SFKPOLKAP","SILESIA","SILVACG","SILVANO","SIMPLE","SITE","SKARBIEC","SKOTAN","SKYLINE","SMSKREDYT","SNIEZKA","SOHODEV","SOLAR","SONEL","SPAC1","SPARKVC","SPC","SRNFIZ","STALEXP","STALPROD","STALPROFI","STANDREW","STANUSCH","STAPORKOW","STARFIT","STARHEDGE","STEMCELLS","STOPKLA","SUNEX","SUNTECH","SURFLAND","SUWARY","SWISSMED","SWISSPSM","SYGNITY","SYMBIO","SYNEKTIK","SYNTHOS","SZAR","TALEX","TAMEX","TARCZYNSKI","TATRY","TAURONPE","TAXNET","TAXUSFUND","TECHMADEX","TELEMEDPL","TELESTR","TELGAM","TELIANI","TERMOEXP","TERMOREX","TESGAS","TFONE","TIM","TOPMEDICA","TORPOL","TOYA","TRAKCJA","TRANSPOL","TRAVELPL","TRIGONPP","TRITON","TVN","UHYECA","ULMA","UNIBEP","UNICREDIT","UNIMA","UNIMOT","UNITED","UNIWHEELS","URSUS","VAKOMTEK","VANTAGE","VARSAVVR","VCP","VEDIA","VELTO","VENTUREIN","VERBICOM","VIDIS","VIGOSYS","VINDEXUS","VISION","VISTAL","VISTULA","VIVID","VOTUM","VOXEL","WADEX","WARIMPEX","WASKO","WAWEL","WBAY","WDBBU","WDX","WERTHHOLZ","WESTAISIC","WESTREAL","WIELTON","WIERZYCL","WIKANA","WILBO","WINVEST","WIRTUALNA","WISTIL","WITTCHEN","WOJAS","WORKSERV","XPLUS","XSYSTEM","YAWAL","YOLO","ZAMET","ZASTAL","ZEPAK","ZPUE","ZREMB","ZUE","ZYWIEC");

    private void execute() {
        BossaSingleFileDataProviderService dataProviderService = new BossaSingleFileDataProviderService();
        dataProviderService.setDataPath("data/mstall.zip");
        int plus = 0;
        int minus = 0;
        int err = 0;
        for(String stockName : stocks) {
            System.out.println(stockName);
            TimeSeries series = TimeSeriesUtils.getSubseries(ZonedDateTime.of(2012,01,01,0,0,0,0, ZoneId.systemDefault()), dataProviderService.load(stockName));
            if (series.getTickCount() < 100) continue;
            StrategyFactory strategyFactory = new IchimokuStrategyFactory();
            StrategyTester tester = new StrategyTester();
            Map<String, String> result = tester.testStrategy(stockName, series, 0, strategyFactory);
            Double totalProfit = Double.valueOf(result.get(StrategyTestingResultFields.TOTAL_PROFIT.toString()));
            Double buyAndHold = Double.valueOf(result.get(StrategyTestingResultFields.BUY_HOLD_PROFIT.toString()));
            Integer trades = Integer.valueOf(result.get(StrategyTestingResultFields.TRADES.toString()));
            if (trades < 10) { err ++; }
            else {
                if (totalProfit > buyAndHold) plus++;
                else minus ++;
            }
        }
        System.out.println(" stocks: " + stocks.size());
        System.out.println("   + : " + plus);
        System.out.println("   - : " + minus);
        System.out.println(" err : " + err);
    }

    public static void main(String[] args) {
        MultistockStrategyTest instance = new MultistockStrategyTest();
        instance.execute();
    }
}
